// Strings.h - contains all language-dependent strings in AppBar

#ifdef ENGLISH
	#define SELECT_MENU                     "Please select a menu first."
	#define SELECT_ITEM                     "Please select an item first"
	#define OLD_DATAFILE_FORMAT             "Old datafile format found.\nDelete it and recreate it."
	#define ERROR_READING_MENUS             "Error reading menu: %d app: %d\nfrom data file: %s. Please\ndelete it and restart AppBar."
	#define ERROR_LINK                      "Error executing link."
	#define FILE_NOT_FOUND                  "File not found:\n%s"
	#define PATH_NOT_FOUND                  "Path not found:\n%s"
	#define OUT_OF_MEM                      "Insufficient memory to start application."
	#define DLL_NOT_FOUND                   "A required DLL necessary to start\nthis application was not found."
	#define RETURNED_ERROR                  "ShellExecute returned error code: %d"
	#define INVALID_FILENAME                "Missing or invalid filename on command line!"
	#define UNKNOWN_OPTION                  "Unknown option: %s"
	#define ERROR_OPENING_REG               "Error opening Registry key!\nUsing default setup."
	#define OBSOLETE_REG_DATA               "Obsolete registry data found.\nDeleting it and installing default data."
	#define WELCOME_MSG                     "Thanks for trying AppBar%s%s!\nIf you find any bugs, please report\nthem to mperham@cs.cornell.edu!"
	#define ERROR_SAVING_REG                "Error saving user options to Registry!"
	#define ERROR_OPENING_DATAFILE  	"Could not open %s for write.\nPlease check the file."
	#define ERROR_AUTOHIDING                "Error autohiding!  Is\nthe Start Menu there?"
	#define ERROR_PLAYING_WAV               "Error playing WAV file.\nCheck path and filename."
	#define ERROR_FINDING_MENU              "Menu not found in linked list!"
	#define ERROR_FINDING_APP               "Application not found in linked list!"
	#define FATAL_ERROR                     "Fatal AppBar Error"
	#define WAV_FILE_TYPES                  "WAV Files\0*.WAV\0"
	#define EXE_FILE_TYPES                  "Executables\0*.EXE;*.COM;*.BAT;*.PIF\0All Files\0*.*\0"
	#define FIND_WAV                        "Find WAV File..."
	#define FIND_EXE                        "Find Executable..."
	#define ERROR_ENTER_WAVNAME             "Please enter a WAV filename."
	#define ERROR_AUTOHIDE_NT               "AutoHide must always be on in Windows NT v3!"
	#define ERROR_NAME_FILENAME             "The application must have a name\nand associated filename."
	#define ERROR_MENUNAME                  "The menu must have a name!"
	#define ERROR_HOTKEY                    "Could not assign hotkey for AppBar!"
	#define CONFIRM_DELETE                  "Are you sure you want to delete\nthis menu and all related apps?"
	#define CONFIRM_DELETE_TITLE    	"Confirm Deletion"
	#define DEFAULT_NAME                    "Default Name"
#else
	#define SELECT_MENU                     "Bitte zuerst ein Men auswhlen."
	#define SELECT_ITEM                     "Bitte zuerst einen Eintrag auswhlen."
	#define OLD_DATAFILE_FORMAT             "Profildatei im alten Datenformat gefunden.\nBitte lschen Sie sie und\n erstellen Sie eine neue."
	#define ERROR_READING_MENUS             "Fehler beim Lesen des Mens: %d Programm: %d\naus Profildatei: %s.\nBitte lschen Sie die Datei und\nstarten Sie Appbar erneut."
	#define ERROR_LINK                      "Fehler beim Starten einer Verknpfung."
	#define FILE_NOT_FOUND                  "Datei nicht gefunden:\n%s"
	#define PATH_NOT_FOUND                  "Dateipfad nicht gefunden:\n%s"
	#define OUT_OF_MEM                      "Zu wenig Speicher um das Programm zu starten."
	#define DLL_NOT_FOUND                   "Die zum Starten dieses Programms\nerforderliche DLL-Datei wurde nicht gefunden."
	#define RETURNED_ERROR                  "ShellExecute fhrte zu folgendem Fehlercode: %d"
	#define INVALID_FILENAME                "Fehlender oder falscher Dateiname\nbeim Aufruf in der DOS-Kommandozeile."
	#define UNKNOWN_OPTION                  "Unbekannte Option: %s"
	#define ERROR_OPENING_REG               "Fehler beim Zugriff auf die Windows-Registrierungsdatei!\nDas Standard-Setup wird benutzt."
	#define OBSOLETE_REG_DATA               "Veraltete Registrierungsinformationen gefunden.\nDiese werden mit den Standarddaten berschrieben."
	#define WELCOME_MSG                     "Vielen Dank fr die Benutzung von AppBar%s%s!\nSollten Sie einen Fehler bemerken, schicken Sie\nbitte eine Email an: mperham@cs.cornell.edu!"
	#define ERROR_SAVING_REG                "Beim Sichern der Benutzer-Optionen in die\nWindows-Registrierungsdatei trat ein Fehler auf!"
	#define ERROR_OPENING_DATAFILE          "Profildatei %s konnte nicht geschrieben werden.\nBitte berprfen Sie die Datei."
	#define ERROR_AUTOHIDING                "Fehler beim automatischen Verstecken\nder Menleiste! Ist dort die Task-Leiste?"
	#define ERROR_PLAYING_WAV               "Fehler beim Abspielen einer WAV-Datei.\nberprfen Sie Pfad und Dateiname."
	#define ERROR_FINDING_MENU              "Das Men konnte nicht gefunden werden!"
	#define ERROR_FINDING_APP               "Das Programm konnte nicht gefunden werden!"
	#define FATAL_ERROR                     "Schwerer Fehler in AppBar aufgetreten!"
	#define WAV_FILE_TYPES                  "WAV-Dateien\0*.WAV\0"
	#define EXE_FILE_TYPES                  "Programm-Dateien\0*.EXE;*.COM;*.BAT;*.PIF;*.LNK\0Alle Dateien\0*.*\0"
	#define FIND_WAV                        "WAV-Datei suchen ..."
	#define FIND_EXE                        "Programm-Datei suchen ..."
	#define ERROR_ENTER_WAVNAME             "Bitte geben Sie den Namen einer WAV-Datei ein."
	#define ERROR_AUTOHIDE_NT               "Automatisches Verstecken kann in Windows NT 3.x nicht abgeschaltet werden!"
	#define ERROR_NAME_FILENAME             "Sie mssen einen Namen und den\nPfad der Programm-Datei eingeben."
	#define ERROR_MENUNAME                  "Das Men mu einen Namen erhalten!"
	#define ERROR_HOTKEY                    "Tastaturkrzel fr AppBar konnte nicht installiert werden!"
	#define CONFIRM_DELETE                  "Sind Sie sicher, da Sie dieses Men und\nalle darin aufgefhrten Eintrge lschen wollen?"
	#define CONFIRM_DELETE_TITLE    	"Bitte Lschen besttigen."
	#define DEFAULT_NAME                    "Standardname"
#endif
